<template>
    <div class="custom-card">
        <div class="d-flex align-items-center justify-content-between mb-3">
            <h2 class="m-0">Weather</h2>
            <format-switcher :formats="formats" />
        </div>
        <div class="row">
            <div class="col-sm-6">
                <div class="form-group">
                    <label class="input-city w-100">
                        City:
                        <div class="position-relative mt-2">
                            <input type="text"
                                   class="form-control"
                                   :class="{'error': $v.city.$error}"
                                   placeholder="Type the city's name"
                                   @keyup="typeCity"
                                   v-model.trim="$v.city.$model" />
                            <div class="icon plus"
                                 v-if="canAddToFavourites"
                                 @click="addToFavourites($v.city.$model)">
                                +
                            </div>
                            <preloader :loading="loading"/>
                        </div>
                    </label>
                    <error :validationObject="$v.city" />
                </div>
                <div class="form-group">
                    <label class="w-100">Find city in the list:</label>
                    <multiselect v-model="multiselect.item"
                                 label="city"
                                 track-by="city"
                                 placeholder="Type to search"
                                 open-direction="bottom"
                                 :options="multiselect.cities"
                                 :multiple="false"
                                 :searchable="true"
                                 :loading="multiselect.loading"
                                 :internal-search="false"
                                 :clear-on-select="false"
                                 :close-on-select="true"
                                 :options-limit="300"
                                 :limit="3"
                                 :max-height="600"
                                 :show-no-results="false"
                                 :hide-selected="true"
                                 @input="getWeatherData({q: multiselect.item.city})"
                                 @search-change="getCities"/>
                </div>
                <div class="form-group">
                    <label for="latitude">Coordinates:</label>
                    <div class="d-flex align-items-center">
                        <input type="number"
                               class="form-control mr-3"
                               @keyup="typeCoord"
                               id="latitude"
                               placeholder="latitude"
                               v-model="params.lat" />
                        <input type="number"
                               class="form-control"
                               @keyup="typeCoord"
                               placeholder="longitude"
                               v-model="params.lon"/>
                    </div>
                </div>
                <button @click="getWeatherData(params)"
                        class="btn btn-success">Get weather by location</button>
            </div>
            <div class="col-sm-6">
                <div v-if="weather">
                    <weather :weather="weather" />
                </div>
            </div>
        </div>
        <div v-if="weather" class="py-3">
            <g-map :coord="weather.coord" @changeCoord="changeCoord" />
        </div>
        <div>
            <forecast :forecast="forecast" />
        </div>
    </div>
</template>

<script>
    import Weather from './Weather'
    import Error from '../helpers/Error'
    import FormatSwitcher from "./FormatSwitcher"
    import Multiselect from 'vue-multiselect'
    import Preloader from '../helpers/Preloader'
    import GMap from '../helpers/GMap'
    import Forecast from '../helpers/Forecast'

    import { mapGetters } from 'vuex'
    import { required, maxLength } from 'vuelidate/lib/validators'
    import weather from "../../mixins/weather";

    export default {
        name: "CurrentWeather",
        components: {
            Weather, Error, FormatSwitcher,
            Multiselect, Preloader, GMap, Forecast
        },
        mixins: [weather],
        data() {
            return {
                loading: false,
                city: null,
                city_valid: false,
                weather: null,
                forecast: null,
                formats: ['metric','imperial'],
                multiselect: {
                    loading: false,
                    cities: [],
                    item: null
                },
                params: {
                    lat: null,
                    lon: null,
                },
                chartdata: {
                    labels: null,
                    datasets: null
                }
            }
        },
        validations: {
            city: {
                required,
                maxLength: maxLength(255),
            }
        },
        computed: {
            ...mapGetters([
                'get'
            ]),
            canAddToFavourites() {
                let cities = this.get('favourites');
                let notExist = cities.indexOf(this.city) < 0;
                return this.city_valid && notExist;
            }
        },
        mounted() {
            this.getLocation();
        },
        methods: {
            changeCoord(coord) {
                this.params.lat = coord.lat;
                this.params.lon = coord.lng;
                this.getWeatherData(this.params);
            },
            getWeatherData(params) {
                this.getWeather(params)
                    .then(data => this.handleWeatherResponse(data))
                    .catch(({response: {data: {message}}}) => {
                        this.handleWeatherError(message)
                    });

                this.getForecast(params)
                    .then(data => {
                        this.forecast = data
                    })
                    .catch(err => console.dir(err));
            },
            getWeatherDebouncer: _.debounce(function() {
                const params = {
                    q: this.$v.city.$model,
                    lat: this.params.lat,
                    lon: this.params.lon
                };
                this.getWeatherData(params);
            }, 2000),
            typeCity() {
                this.loading = true;
                this.city_valid = false;
                this.getWeatherDebouncer();
            },
            typeCoord() {
                this.loading = true;
                this.city_valid = false;
                this.$v.city.$model = null;
                this.getWeatherDebouncer();
            },
            addToFavourites(city) {
                if (this.get('favourites')) {
                    let cities = this.get('favourites');
                    let indexOf = cities.indexOf(city);
                    if (indexOf !== -1) {
                        this.$notify({
                            group: 'notification',
                            type: 'error',
                            text: 'This city has already in favourites'
                        })
                    } else {
                        cities.push(city);
                        this.$store.commit('set', {key: 'favourites', value: cities});
                        this.$notify({
                            group: 'notification',
                            type: 'success',
                            text: `${city} has added to favourites`
                        });
                        localStorage.setItem('favourites', JSON.stringify(cities));
                    }
                } else {
                    let cities = [];
                    cities.push(city);
                    localStorage.setItem('favourites', JSON.stringify(cities));
                }
            },
            getCities(query) {
                this.multiselect.loading = true;
                axios(`${process.env.VUE_APP_CITIES_API}/v1/geo/cities`, {
                    params: {
                        namePrefix: query,
                        limit: 100
                    }
                })
                    .then(({data: {data}}) => {
                        this.multiselect.cities = data;
                        this.multiselect.loading = false;
                    })
                    .catch(err => {
                        console.dir(err);
                        this.multiselect.loading = false;
                    });
            },
            getLocation() {
                const position = (pos) => {
                    this.params.lat = pos.coords.latitude;
                    this.params.lon = pos.coords.longitude;
                    this.getWeatherData(this.params);
                    this.getForecast(this.params)
                        .then(data => this.forecast = data)
                        .catch(err => console.dir(err));
                };
                const error = (err) => {
                    console.dir(err);
                };
                navigator.geolocation.getCurrentPosition(position.bind(this), error);
            },
            handleWeatherResponse(data) {
                this.loading = false;
                this.city = data.name;
                this.multiselect.item = {city: data.name};
                this.params.lat = data.coord.lat;
                this.params.lon = data.coord.lon;
                this.city_valid = true;
                this.weather = data;
                this.weather.format = JSON.parse(JSON.stringify(this.get('format')));
            },
            handleWeatherError(message) {
                this.$notify({
                    group: 'notification',
                    type: 'warn',
                    text: message
                });
                this.city = null;
                this.city_valid = false;
                this.loading = false;
                this.weather = null;
            }
        }
    }
</script>

<style scoped lang="scss">
    $plus_width: 22px;

    .input-city {
        margin: 0;

        input {
            padding-right: calc(#{$plus_width} + 10px);
        }

        .app-preloader {
            right: 10px;
            top: 50%;
        }
    }

    .plus {
        width: $plus_width;
        height: $plus_width;
        border-radius: 50%;
        box-shadow: 0 0 1px 1px silver;
        display: flex;
        align-items: center;
        justify-content: center;
        background-color: green;
        color: white;
        font-weight: bold;
        font-size: 20px;
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        right: 5px;
    }
</style>